<?php
/**************************************************
  Coppermine Plugin - Sitemap Generator
  *************************************************
  Copyright (c) 2011 Allyson Moisan
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License version 3
  as published by the Free Software Foundation.
***************************************************/

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

$thisplugin->add_action('plugin_install','sitemap_gen_install');
$thisplugin->add_action('plugin_uninstall','sitemap_gen_uninstall');

function sitemap_gen_install () {
	global $CONFIG;
	
	require_once "./plugins/sitemap_generator/lang/english.php";
	if ($CONFIG['lang'] != 'english' && file_exists("./plugins/sitemap_generator/lang/{$CONFIG['lang']}.php"))
		require_once "./plugins/sitemap_generator/lang/{$CONFIG['lang']}.php";

	$superCage = Inspekt::makeSuperCage();
	
	if($superCage->post->getAlpha('submit') == $lang_plugin_sitemap_gen['install']){ 
		/* delete previous plugin config options if necessary (just in case) */
		cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name='plugin_sitemap_gen_server'");
		cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name='plugin_sitemap_gen_user'");
		cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name='plugin_sitemap_gen_pass'");
		cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name='plugin_sitemap_gen_path'");	

		/* initialize plugin config options */
		cpg_db_query("INSERT INTO {$CONFIG['TABLE_CONFIG']} (name, value) VALUES ('plugin_sitemap_gen_server', 'localhost')");
		cpg_db_query("INSERT INTO {$CONFIG['TABLE_CONFIG']} (name, value) VALUES ('plugin_sitemap_gen_user', '')");
		cpg_db_query("INSERT INTO {$CONFIG['TABLE_CONFIG']} (name, value) VALUES ('plugin_sitemap_gen_pass', '')");
		cpg_db_query("INSERT INTO {$CONFIG['TABLE_CONFIG']} (name, value) VALUES ('plugin_sitemap_gen_path', '/public_html/')");

		return true;
	}
	
	else return 1;
}



function sitemap_gen_uninstall () {
	global $CONFIG, $thisplugin;
		
	if (!checkFormToken()) {
		cpg_die(ERROR, $lang_errors['invalid_form_token'], __FILE__, __LINE__);
    }

	/* Delete sitemap files and directory */
	$base = rtrim($CONFIG['ecards_more_pic_target'], '/');
	$public = "AND (ISNULL(alb_password) OR alb_password = '') AND visibility = '0'";
	$cats = cpg_db_query("SELECT cid FROM {$CONFIG['TABLE_CATEGORIES']}");
	
	if($cats) {
		while(list($cid) = mysql_fetch_row($cats)) {
			list($alb_count) = mysql_fetch_row(cpg_db_query( "SELECT COUNT(aid) FROM {$CONFIG['TABLE_ALBUMS']} WHERE category = '$cid' $public LIMIT 1" ));
			/* don't worry about categories with no albums */
			if (!$alb_count) continue;
			
			unlink('sitemaps/cat' . $cid . '-sitemap.xml');
		}
	}
	
	unlink('sitemaps/sitemap_index.xml');
	rmdir('sitemaps');
	
	/* Remove database entries */
	cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name='plugin_sitemap_gen_server'");
	cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name='plugin_sitemap_gen_user'");
	cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name='plugin_sitemap_gen_pass'");
	cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name='plugin_sitemap_gen_path'");
	
	return true;
} 

?>