<?php
/**************************************************
  Coppermine Plugin - Sitemap Generator
  *************************************************
  Copyright (c) 2011 Allyson Moisan
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License version 3
  as published by the Free Software Foundation.
***************************************************/

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

global $CONFIG, $lang_errors;

if (!GALLERY_ADMIN_MODE) {
    cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);
}

require_once "./plugins/sitemap_generator/lang/english.php";
if ($CONFIG['lang'] != 'english' && file_exists("./plugins/sitemap_generator/lang/{$CONFIG['lang']}.php")) {
    require_once "./plugins/sitemap_generator/lang/{$CONFIG['lang']}.php";
}

$sanitization_array = array(
    'plugin_sitemap_gen_server' => array('type' => 'raw', 'regex_ok' => '/^.+$/'),
    'plugin_sitemap_gen_user' => array('type' => 'raw', 'regex_ok' => '/^.+$/'),
	'plugin_sitemap_gen_pass' => array('type' => 'raw', 'regex_ok' => '/^.+$/'),
	'plugin_sitemap_gen_path' => array('type' => 'raw', 'regex_ok' => '/^.+$/'),
);


// get sanitized POST parameters
    if ($superCage->post->keyExists('submit')) {
        //Check if the form token is valid
        if(!checkFormToken()){
            cpg_die(ERROR, $lang_errors['invalid_form_token'], __FILE__, __LINE__);
        }
        $config_changes_counter = 0;
      foreach ($sanitization_array as $san_key => $san_value) {
          if (isset($CONFIG[$san_key]) == TRUE) { // only loop if config value is set --- start
              if ($san_value['type'] == 'checkbox') { // type is checkbox --- start
                if ($superCage->post->getInt($san_key) == $san_value['max'] && $CONFIG[$san_key] != $san_value['max']) {
                    $CONFIG[$san_key] = $san_value['max'];
                    cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                    $config_changes_counter++;
                } elseif($superCage->post->getInt($san_key) == $san_value['min'] && $CONFIG[$san_key] != $san_value['min']) {
                    $CONFIG[$san_key] = $san_value['min'];
                    cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                    $config_changes_counter++;
                } elseif($superCage->post->keyExists($san_key) != TRUE && $CONFIG[$san_key] != '0') {
                    $CONFIG[$san_key] = 0;
                    cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                    $config_changes_counter++;
                }
              } // type is checkbox --- end
              if ($san_value['type'] == 'int') { // type is integer --- start
                  if ($superCage->post->getInt($san_key) <= $san_value['max'] && $superCage->post->getInt($san_key) >= $san_value['min'] && $superCage->post->getInt($san_key) != $CONFIG[$san_key]) {
                      $CONFIG[$san_key] = $superCage->post->getInt($san_key);
                      cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                      $config_changes_counter++;
                  }
              } // type is integer --- end
              if ($san_value['type'] == 'raw') { // type is raw --- start
                  if (isset($san_value['regex_ok']) == TRUE && preg_match($san_value['regex_ok'], $superCage->post->getRaw($san_key)) && $superCage->post->getRaw($san_key) != $CONFIG[$san_key]) {
                      $CONFIG[$san_key] = $superCage->post->getRaw($san_key);
                      if ($superCage->post->getRaw($san_key) == 'none') {
                        $CONFIG[$san_key] = '';
                      }
                      cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                      $config_changes_counter++;
                  }
              } // type is raw --- end
              if ($san_value['type'] == 'array') { // type is array --- start              
                  $evaluate_value = $superCage->post->getRaw($san_key);
                  if (is_array($evaluate_value) && isset($san_value['regex_ok']) == TRUE && isset($san_value['delimiter']) == TRUE) {
                      $temp = '';
                      for ($i = 0; $i <= count($evaluate_value); $i++) {
                          if (preg_match($san_value['regex_ok'], $evaluate_value[$i])) {
                              $temp .= $evaluate_value[$i] . $san_value['delimiter'];
                          }
                      }
                      unset($evaluate_value);
                      $evaluate_value = rtrim($temp, $san_value['delimiter']);
                      unset($temp);
                  }
                  if ($evaluate_value != $CONFIG[$san_key]) {
                      $CONFIG[$san_key] = $evaluate_value;
                      cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                      $config_changes_counter++;
                  }
              } // type is array --- end
          } // only loop if config value is set --- end
      }
    }
	
$option_output['plugin_sitemap_gen_server'] = 'value="'.$CONFIG['plugin_sitemap_gen_server'].'"';
$option_output['plugin_sitemap_gen_user'] = 'value="'.$CONFIG['plugin_sitemap_gen_user'].'"';
$option_output['plugin_sitemap_gen_pass'] = 'value="'.$CONFIG['plugin_sitemap_gen_pass'].'"';
$option_output['plugin_sitemap_gen_path'] = 'value="'.$CONFIG['plugin_sitemap_gen_path'].'"';

pageheader($lang_plugin_sitemap_gen['sitemap_gen']);
list($timestamp, $form_token) = getFormToken();
$superCage = Inspekt::makeSuperCage();

echo '<form name="cpgform" id="cpgform" action="'.$_SERVER['REQUEST_URI'].'" method="post">';

starttable('100%', $lang_plugin_sitemap_gen['ftp_config'], 2, 'cpg_zebra');

if ($superCage->post->keyExists('submit')) {
    echo <<< EOT
	<tr>
		<td class="tableh2" colspan="2">
EOT;
    if ($config_changes_counter > 0) {
        msg_box('', $lang_plugin_sitemap_gen['settings_saved'], '', '', 'success');
    } else {
        msg_box('', $lang_plugin_sitemap_gen['no_changes'], '', '', 'validation');
    }
echo <<< EOT
		</td>
	</tr>
EOT;
}

echo <<< EOT
              <tr>
                <td class="tableb" align="right">
					<label for="plugin_sitemap_gen_server" class="text">{$lang_plugin_sitemap_gen['ftp_server']}</label>
                </td>
                <td class="tableb">
                  <input type="text" name="plugin_sitemap_gen_server" id="plugin_sitemap_gen_server" {$option_output['plugin_sitemap_gen_server']} class="textinput" style="width:25%" /> {$lang_plugin_sitemap_gen['ftp_server_exp']}
                </td>
              </tr>
			  <tr>
                <td class="tableb" align="right">
					<label for="plugin_sitemap_gen_user" class="text">{$lang_plugin_sitemap_gen['ftp_user']}</label>
                </td>
                <td class="tableb">
                  <input type="text" name="plugin_sitemap_gen_user" id="plugin_sitemap_gen_user" {$option_output['plugin_sitemap_gen_user']} class="textinput" style="width:25%" />
                </td>
              </tr>
			  <tr>
                <td class="tableb" align="right">
					<label for="plugin_sitemap_gen_pass" class="text">{$lang_plugin_sitemap_gen['ftp_pass']}</label>
                </td>
                <td class="tableb">
                  <input type="password" name="plugin_sitemap_gen_pass" id="plugin_sitemap_gen_pass" {$option_output['plugin_sitemap_gen_pass']} class="textinput" style="width:25%" />
                </td>
              </tr>
			  <tr>
                <td class="tableb" align="right">
					<label for="plugin_sitemap_gen_path" class="text">{$lang_plugin_sitemap_gen['ftp_path']}</label>
                </td>
                <td class="tableb">
                  <input type="text" name="plugin_sitemap_gen_path" id="plugin_sitemap_gen_path" {$option_output['plugin_sitemap_gen_path']} class="textinput" style="width:25%" /> {$lang_plugin_sitemap_gen['ftp_path_exp1']} {$lang_plugin_sitemap_gen['ftp_path_exp2']}
                </td>
              </tr>
              <tr>
                <td class="tablef" colspan="2">
					<input type="hidden" name="form_token" value="{$form_token}" />
					<input type="hidden" name="timestamp" value="{$timestamp}" />
					<button type="submit" name="submit" class="button" value="{$lang_plugin_sitemap_gen['ftp_submit']}" />{$lang_plugin_sitemap_gen['ftp_submit']}</button>
					<button type="button" name="cancel" class="button" onclick="window.location='pluginmgr.php';" value="{$lang_plugin_sitemap_gen['ftp_cancel']}" />{$lang_plugin_sitemap_gen['ftp_cancel']}</button>
                </td>
              	</tr>
EOT;
endtable();
echo <<< EOT
</form>
EOT;
pagefooter();

?>