<?php
/**************************************************
  Coppermine Plugin - Sitemap Generator
  *************************************************
  Copyright (c) 2011 Allyson Moisan
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License version 3
  as published by the Free Software Foundation.
***************************************************/

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

global $CONFIG, $lang_errors;

if (!GALLERY_ADMIN_MODE) cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);
require_once "./plugins/sitemap_generator/lang/english.php";
if ($CONFIG['lang'] != 'english' && file_exists("./plugins/sitemap_generator/lang/{$CONFIG['lang']}.php")) {
    require_once "./plugins/sitemap_generator/lang/{$CONFIG['lang']}.php";
}

$sitemap = '';
$base = rtrim($CONFIG['ecards_more_pic_target'], '/');
$stylesheet = $base . '/plugins/sitemap_generator/xml-sitemap.xsl';
$public = "AND (ISNULL(alb_password) OR alb_password = '') AND visibility = '0'";
$cats = cpg_db_query("SELECT cid FROM {$CONFIG['TABLE_CATEGORIES']}");

DEFINE ('FTP_SERVER', $CONFIG['plugin_sitemap_gen_server']);
DEFINE ('FTP_USER', $CONFIG['plugin_sitemap_gen_user']);
DEFINE ('FTP_PASS', $CONFIG['plugin_sitemap_gen_pass']);
DEFINE ('FTP_PATH', $CONFIG['plugin_sitemap_gen_path']);

if (!$cats) cpg_die(ERROR, $lang_plugin_sitemap_gen['empty_gallery_error'], __FILE__, __LINE__);

/* Build Sitemap Index */
$sitemap = '<?xml version="1.0" encoding="UTF-8"?>';
$sitemap .= '<?xml-stylesheet type="text/xsl" href="'.$stylesheet.'"?>';
$sitemap .= '<sitemapindex xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">' . "\n";

while(list($cid) = mysql_fetch_row($cats))
{	
	list($alb_count) = mysql_fetch_row(cpg_db_query( "SELECT COUNT(aid) FROM {$CONFIG['TABLE_ALBUMS']} WHERE category = '$cid' $public LIMIT 1" ));
	// don't include categories with no albums
	if (!$alb_count) continue;
	
	$newest_alb = cpg_db_query("SELECT a.aid, MAX(ctime) FROM {$CONFIG['TABLE_ALBUMS']} AS a INNER JOIN {$CONFIG['TABLE_PICTURES']} AS p ON p.aid = a.aid WHERE category = $cid $public GROUP BY a.aid ORDER BY ctime DESC LIMIT 1");
	list($aid, $date) = mysql_fetch_row($newest_alb);
	$date = date( 'c', $date );
	
	$sitemap .= '<sitemap>' . "\n";
	$sitemap .= '<loc>'. $base . '/sitemaps/cat' . $cid . '-sitemap.xml</loc>' . "\n";
	$sitemap .= '<lastmod>' . $date . '</lastmod>' . "\n";
	$sitemap .= '</sitemap>' . "\n";
}

$sitemap .= '</sitemapindex>';

/* Output Sitemap Index to a file in directory named sitemaps */
if (!is_dir('sitemaps')) {
	if(!mkdir('sitemaps', 0775)) {
		mkDirFix($base, 'sitemaps');
	}
}

if (!file_put_contents('sitemaps/sitemap_index.xml', $sitemap, LOCK_EX))
	mkFileFix($sitemap, 'sitemaps/sitemap_index.xml');

$sitemap = '';
$cats = cpg_db_query("SELECT cid FROM {$CONFIG['TABLE_CATEGORIES']}");

if (!$cats) die('No gallery data');

/* Build Sitemaps */
while(list($cid) = mysql_fetch_row($cats))
{	
	$sitemap = '<?xml version="1.0" encoding="UTF-8"?>';
	$sitemap .= '<?xml-stylesheet type="text/xsl" href="'.$stylesheet.'"?>';
	$sitemap .= '<urlset xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" ';
	$sitemap .= 'xsi:schemaLocation="http://www.sitemaps.org/schemas/sitemap/0.9 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd" ';
	$sitemap .= 'xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">'."\n";
	
	list($alb_count) = mysql_fetch_row(cpg_db_query( "SELECT COUNT(aid) FROM {$CONFIG['TABLE_ALBUMS']} WHERE category = '$cid' $public LIMIT 1" ));
	// don't include categories with no albums
	if (!$alb_count) continue;
	
	$newest_alb = cpg_db_query("SELECT a.aid, MAX(ctime) FROM {$CONFIG['TABLE_ALBUMS']} AS a INNER JOIN {$CONFIG['TABLE_PICTURES']} AS p ON p.aid = a.aid WHERE category = $cid $public GROUP BY a.aid ORDER BY ctime DESC LIMIT 1");
	list($aid, $date) = mysql_fetch_row($newest_alb);
	$date = date( 'c', $date );
	
	$sitemap .= '<url>' . '\n';
	$sitemap .= '<loc>'. $base . '/index.php?cat=' . $cid . '</loc>' . '\n';
	$sitemap .= '<lastmod>' . $date . '</lastmod>' . "\n";
	$sitemap .= '<changefreq>daily</changefreq>' . '\n';
	$sitemap .= '<priority>1</priority>' . '\n';
	$sitemap .= '</url>';
	
	$albs = cpg_db_query("SELECT a.aid, MAX(ctime) FROM {$CONFIG['TABLE_ALBUMS']} AS a INNER JOIN {$CONFIG['TABLE_PICTURES']} AS p ON p.aid = a.aid WHERE category = '$cid' $public GROUP BY a.aid");
	
	while(list($aid, $lastmod) = mysql_fetch_row($albs)) {
		$date = date ( 'c', $lastmod);
		$sitemap .= '<url>' . '\n';
		$sitemap .= '<loc>' . $base . '/thumbnails.php?album=' . $aid . '</loc>' . '\n';
		$sitemap .= '<lastmod>' . $date . '</lastmod>' . "\n";
		$sitemap .= '<changefreq>daily</changefreq>' . '\n';
		$sitemap .= '<priority>1</priority>' . '\n';
		$sitemap .= '</url>' . '\n';
	
		$pics = cpg_db_query("SELECT pid, ctime FROM {$CONFIG['TABLE_ALBUMS']} AS a INNER JOIN {$CONFIG['TABLE_PICTURES']} AS p ON p.aid = a.aid WHERE p.aid = '$aid'");
	
		while(list($pid, $lastmod) = mysql_fetch_row($pics)) {
			$date = date ( 'c', $lastmod);
			$sitemap .= '<url>' . '\n';
			$sitemap .= '<loc>' . $base . '/displayimage.php?pos=-' . $pid . '</loc>' . '\n';
			$sitemap .= '<lastmod>' . $date . '</lastmod>' . "\n";
			$sitemap .= '<changefreq>monthly</changefreq>' . '\n';
			$sitemap .= '<priority>0.5</priority>' . '\n';
			$sitemap .= '</url>' . '\n';
		}
	}
	
	$sitemap .= '</urlset>';
	if(!file_put_contents('sitemaps/cat' . $cid . '-sitemap.xml', $sitemap, LOCK_EX))
		mkFileFix ($sitemap, 'sitemaps/cat' . $cid . '-sitemap.xml');
	$sitemap = '';
}

/*
  * Returns the created directory or false.
  *
  * @param Base directory (String)
  * @param Directory to create (String)
  * @return Created directory or false;
  */
		
function mkDirFix ($base, $path) {
	$conn_id = ftp_connect(FTP_SERVER);
	$currPath = FTP_PATH . $path;
	if(!$conn_id) {
		return false;
	}
			
	if (ftp_login($conn_id, FTP_USER, FTP_PASS)) {
       	if(!ftp_mkdir($conn_id,$currPath)) {
			ftp_close($conn_id);
			return false;
		}
		$perms = ftp_chmod($conn_id,0775,$currPath);
	}
				
	$endpath = 'init';
				
	if(!ftp_chdir($conn_id,$currPath))
		$endpath = 'empty';
	else $endpath = ftp_pwd($conn_id);
				
	ftp_close($conn_id);
	return $endPath;	
}

/*
  * Returns the number of bytes written to file or false.
  *
  * @param Contents to be written to file (String)
  * @param Path of file to create (String)
  * @return The number of bytes writter to file or false;
  */
  
function mkFileFix ($filecontents, $filepath) {
	$conn_id = ftp_connect(FTP_SERVER);
	if(!$conn_id) {
		return false;
	}

	$bytes = 0;		
	
	if (ftp_login($conn_id, FTP_USER, FTP_PASS)) {
 		$hostname = FTP_USER . ":" . FTP_PASS . "@" . FTP_SERVER . FTP_PATH . $filepath;
 
 		/* create a stream context telling PHP to overwrite the file */
 		$options = array('ftp' => array('overwrite' => true));
	 	$stream = stream_context_create($options);
 
		 /* and finally, put the contents */
 		if(!$bytes = file_put_contents($hostname, $filecontents, LOCK_EX, $stream)) {
			ftp_close($conn_id);
			return false;
		}
	}
	
	ftp_close($conn_id);
	return $bytes;
}

/* Redirect user after success */
pageheader($lang_common['information'],"<meta http-equiv=\"refresh\" content=\"4;url=" . $base . "\">");
msg_box('', $lang_plugin_sitemap_gen['success'], '', '', 'success');
pagefooter();

?>